#!/bin/bash
#
# JOSE TERRA <jose.terra@hostgator.com.br>
# LINUX SYSTEMS ADMINISTRATOR II
# HOSTGATOR BRAZIL (C) 2015
#

SHOW_HELP(){
printf "
[?] CONECTAR SERVIDORES COMPARTILHADOS POR CHAVE SSH A PARTIR DO WIZARD USANDO SCRIPT LOCAL
conkey --source [SERVIDOR_ORIGEM] --destination [SERVIDOR_DESTINO]

[?] CONECTAR SERVIDORES COMPARTILHADOS POR CHAVE SSH A PARTIR DO WIZARD USANDO SCRIPT REMOTO
bash <(GET http://git.hostgator.com.br/jose.terra/dev/raw/master/conkey) --source [SERVIDOR_ORIGEM] --destination [SERVIDOR_DESTINO]

[!] COMPATIVEL COM OS SERVIDORES BRA (PLUS) | SRV (REVENDA) | BR (HOSPEDAGEM)
[!] COMPATIVEL COM O NOVO SCRIPT HGFIREWALL

"
}

if [ $# -lt "4" ] ; then SHOW_HELP ; exit 0 ; fi


while [ "$1" != "" ]; do

case "$1" in

--source)
SOURCE="$2" 
shift 2 
;;

--destination)
DESTINATION="$2"
shift 2
;;

*)
SHOW_HELP
exit 0
;;

esac
done

## PORTA DEFAULT SSH SERVIDORES COMPARTILHADOS
SOURCE_PORT="22" 
DESTINATION_PORT="22" 

## IDENTIFICANDO TIPO  DE SERVIDOR
SOURCE_PREFIX=$(echo "$SOURCE" |cut -c -3)
DESTINATION_PREFIX=$(echo "$DESTINATION" |cut -c -3)

## OBTENDO O PREFIXO PARA SERVIDORES BR 
if [[ $SOURCE_PREFIX =~ ^br[0-9] ]] ; then SOURCE_PREFIX=$(echo "$SOURCE_PREFIX" |cut -c -2) ; fi
if [[ $DESTINATION_PREFIX =~ ^br[0-9] ]] ; then DESTINATION_PREFIX=$(echo "$DESTINATION_PREFIX" |cut -c -2) ; fi

## VERIFICANDO A COMPATIBILIDADE COM O SERVIDOR DE ORIGEM
if [ $SOURCE_PREFIX != "srv" ] && [ $SOURCE_PREFIX != "br" ] && [ $SOURCE_PREFIX != "bra" ] ; then

printf "\n"
printf "[!] O SCRIPT E COMPATIVEL APENAS COM OS SERVIDORES COMPARTILHADOS !!!"
printf "\n\n"
exit 0

fi

## VERIFICANDO A COMPATIBILIDADE COM O SERVIDOR DE DESTINO
if [ $DESTINATION_PREFIX != "srv" ] && [ $DESTINATION_PREFIX != "br" ] && [ $DESTINATION_PREFIX != "bra" ] ; then

printf "\n"
printf "[!] O SCRIPT E COMPATIVEL APENAS COM OS SERVIDORES COMPARTILHADOS !!!"
printf "\n\n"
exit 0

fi

## VERIFICA SE SERVIDOR DE ORIGEM ESTA RESPONDENDO
echo -e "\n[+] DISPARANDO PING CONTRA O SERVIDOR DE ORIGEM '$SOURCE'..." ;
ping -c5 $SOURCE &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e "[!] O SERVIDOR DE ORIGEM '$SOURCE' ESTA INDISPONIVEL OU E INVALIDO !!!\n" ; exit 0 ; fi ;

## VERIFICA SE SERVIDOR DE DESTINO ESTA RESPONDENDO
echo "[+] DISPARANDO PING CONTRA O SERVIDOR DE DESTINO '$DESTINATION'..." ;
ping -c5 $DESTINATION &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e "[!] O SERVIDOR DE DESTINO '$DESTINATION' ESTA INDISPONIVEL OU E INVALIDO !!!\n" ; exit 0 ; fi ;

## TESTA CONEXAO COM A PORTA NO SERVIDOR DE ORIGEM
echo "[+] TESTANDO CONEXAO COM O SERVIDOR DE ORIGEM '$SOURCE' PORTA '$SOURCE_PORT'..." ;
nc -v -z $SOURCE $SOURCE_PORT &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e "[!] NAO FOI POSSIVEL SE CONECTAR AO SERVIDOR DE ORIGEM '$SOURCE' USANDO A PORTA SSH '$SOURCE_PORT' !!!\n" ; exit 0 ; fi ;

## TESTA CONEXAO COM A PORTA NO SERVIDOR DE DESTINO
echo "[+] TESTANDO CONEXAO COM O SERVIDOR DE DESTINO '$DESTINATION' PORTA '$DESTINATION_PORT'..." ;
nc -v -z $DESTINATION $DESTINATION_PORT &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e "[!] NAO FOI POSSIVEL SE CONECTAR AO SERVIDOR DE DESTINO '$DESTINATION' USANDO A PORTA SSH '$DESTINATION_PORT' !!!\n" ; exit 0 ; fi ;

## ADICIONA O DOMINIO PARA RESOLVER NOME DO SERVIDORES COMPARTILHADOS DE DESTINO
if [[ $DESTINATION =~ ^srv[0-9]{1,3} ]] ; then DESTINATION_DOMAIN=".prodns.com.br" ; fi
if [[ $DESTINATION =~ ^br[0-9]{1,3} ]] ; then DESTINATION_DOMAIN=".hostgator.com.br" ; fi
if [[ $DESTINATION =~ ^bra[0-9]{1,2} ]] ; then DESTINATION_DOMAIN=".hostgator.com.br" ; fi

## ADICIONA O DOMINIO PARA RESOLVER NOME DO SERVIDORES COMPARTILHADOS DE ORIGEM
if [[ $SOURCE =~ ^srv[0-9]{1,3} ]] ; then SOURCE_DOMAIN=".prodns.com.br" ; fi
if [[ $SOURCE =~ ^br[0-9]{1,3} ]] ; then SOURCE_DOMAIN=".hostgator.com.br" ; fi
if [[ $SOURCE =~ ^bra[0-9]{1,2} ]] ; then SOURCE_DOMAIN=".hostgator.com.br" ; fi

## VERIFICANDO SE SERVIDOR DE ORIGEM JA POSSUI CONEXAO COM O SERVIDOR DE DESTINO
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT " ssh -q -o ConnectTimeout=3 -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no ${DESTINATION}${DOMAIN} -p $DESTINATION_PORT exit " &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e '[!] CONEXAO POR CHAVE SSH FALHOU !!!' ; else echo -e '[+] CONEXAO POR CHAVE SSH REALIZADA COM SUCESSO !!!\n' ; exit 0 ; fi

## REMOVE OS ARQUIVOS 'id_rsa' E 'id_rsa.pub' APOS A FALHA NO TESTE DE CONEXAO
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT "if [ -e "/root/.ssh/id_rsa.pub" ] && [ -e "/root/.ssh/id_rsa" ] ; then rm -rf /root/.ssh/id_rsa.pub ; rm -rf /root/.ssh/id_rsa ; fi ;"

## SE EXISTIR O ARQUIVO 'id_rsa.pub' E NAO EXISTIR 'id_rsa' REMOVE O ARQUIVO 'id_rsa.pub'
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT "if [ -e "/root/.ssh/id_rsa.pub" ] && [ ! -e "/root/.ssh/id_rsa" ] ; then rm -rf /root/.ssh/id_rsa.pub ; fi ; "

## SE NAO EXISTIR O ARQUIVO 'id_rsa.pub' E EXISTIR 'id_rsa' REMOVE O ARQUIVO 'id_rsa'
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT "if [ ! -e "/root/.ssh/id_rsa.pub" ] && [ -e "/root/.ssh/id_rsa" ] ; then rm -rf /root/.ssh/id_rsa ; fi ; "
 

## REMOVE QUALQUER CHAVE SSH COM O NOME DO SERVIDOR NO ARQUIVO '/root/.ssh/authorized_keys2' NO DESTINO
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT " egrep -i 'root@${SOURCE}${SOURCE_DOMAIN}' /root/.ssh/authorized_keys2" &>/dev/null

if [ `echo $?` = "0" ] ; then

        /usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT "/bin/sed -i '/${SOURCE}${SOURCE_DOMAIN}/d' /root/.ssh/authorized_keys2"

fi

echo "[+] CRIANDO CHAVE SSH RSA NO SERVIDOR DE ORIGEM '${SOURCE}'..."

## SE NAO EXISTIR OS ARQUIVOS 'id_rsa.pub' E 'id_rsa' CRIA UMA NOVA CHAVE
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT "if [ ! -e "/root/.ssh/id_rsa.pub" ] && [ ! -e "/root/.ssh/id_rsa" ] ; then ssh-keygen -q -t rsa -f /root/.ssh/id_rsa -N '' ; fi ; " ;

## CRIA UM DIRETORIO TEMPORARIO ALEATORIO PARA ARMAZENAR OS DADOS DURANTE CADA EXECUCAO
TMPDIR="/tmp/$(echo $RANDOM)" ; if [ ! -d "$TMPDIR" ] ; then mkdir -p $TMPDIR ; else TMPDIR="/tmp/$(echo $RANDOM)" ; mkdir -p $TMPDIR ; fi ;

## OBTEM O IP PRIMAIRO DO SERVIDOR DE ORIGEM A PARTID DO ARQUIVO '/var/cpanel/mainip'
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT "cat /var/cpanel/mainip" > $TMPDIR/ip.txt 

## CRIA UMA COPIA DA CHAVE NO ARQUIVO TEMPORARIO 'key.txt' 
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT  "cat /root/.ssh/id_rsa.pub" > $TMPDIR/key.txt ;

## DEFINE O ARQUIVO TEMPORARIO DA CHAVE
SSH_KEY=`<$TMPDIR/key.txt`

## DEFINE ARQUIVO TEMPORARIO DO IP PRINCIPAL DO SERVIDOR
PRIMARY_IP=`<$TMPDIR/ip.txt`

## CRIA O DIRETORIO '/root/.ssh' CASO NAO EXISTA NO SERVIDOR DE DESTINO
/usr/bin/sudo ssh  -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT  "if [ ! -d "/root/.ssh" ] ; then mkdir -p /root/.ssh ; fi ; "

## CRIA O ARQUIVO 'authorized_keys2' CASO NAO EXISTA NO SERVIDOR DE DESTINO
/usr/bin/sudo ssh  -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT "if [ ! -e "/root/.ssh/authorized_keys2" ] ; then touch /root/.ssh/authorized_keys2 ; fi ; " ;

## ADICIONA A CHAVE DO ARQUIVO 'key.txt' NO ARQUIVO '/root/.ssh/authorized_keys2' DO SERVIDOR DE DESTINO
/usr/bin/sudo ssh  -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT  "echo $SSH_KEY >> /root/.ssh/authorized_keys2" ;

echo "[+] CONFIGURANDO REGRA DE FIREWALL NO SERVIDOR DE DESTINO '$DESTINATION'..." 

## ADICIONA A REGRA DE FIREWALL NO SERVIDOR DE DESTINO
/usr/bin/sudo ssh  -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $DESTINATION_PORT "iptables -I INPUT -p tcp --dport 22 -s $PRIMARY_IP -j ACCEPT"

echo "[+] TESTANDO CONEXAO DO SERVIDOR DE ORIGEM '$SOURCE' PORTA '$SOURCE_PORT' COM O DESTINO '$DESTINATION' PORTA '$DESTINATION_PORT'..."

## REALIZA TESTE DE CONEXAO A PARTIR DO SERVIDOR DE ORIGEM PARA O SERVIDOR DE DESTINO
/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $SOURCE -p $SOURCE_PORT " ssh -q -o ConnectTimeout=3 -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no ${DESTINATION}${DESTINATION_DOMAIN} -p $DESTINATION_PORT exit " &>/dev/null ; if [ `echo $?` != "0" ] ; then echo -e '[!] CONEXAO POR CHAVE SSH FALHOU !!!' ; echo -e '[!] REALIZE UM NOVO TESTE E SE PERSISTIR VERIFIQUE MANUALMENTE...\n' ; else echo -e '[+] CONEXAO POR CHAVE SSH REALIZADA COM SUCESSO !!!\n' ; fi ;

## REMOVE O DIRETORIO TEMPORARIO DO SCRIPT
if [ -d "$TMPDIR" ] ; then rm -rf $TMPDIR ; fi ;

