#!/bin/sh
##################################################################
# Author       : Davi Junior
# Email        : 
# Info         : copiar arquivos via LFTP
# Version      : 1.0 ( beta )
# Contributors : Leonardo Peixoto 
# Email        : leonardo.ipx@gmail.com
# Project      : https://github.com/leonardoipx/
#
# CHANGELOG
# 18/01/15 - LP: Correção de variaveis
# 
#
# TO-DO #
# 
##################################################################
SSH="/usr/bin/sudo ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"

function usage
{
    echo -e "\nUsage: \n\nmigrar -u user -s source server(brXX) -d destination server(brYY)  ### ONE ACCOUNT MIGRATION\nmigrar -r user -s source server(srvXX) -d destination server(srvYY)  ### RESELLER MIGRATION\n\n### To keep backups on destination server(/home/hgtransf/XXX-000000)\nmigrar -r user -s source server(srvXX) -d destination server(srvYY) -t XXX-000000\n"
    
}

## MENU

if [[ $# -eq 0 ]] ; then
usage
exit 0
fi

while [ "$1" != "" ]; do
    case "$1" in
      -u | -r)
	  user="$2"
	  if [ "$1" == "-r" ]; then mode="r"; fi
	  shift 2
	  ;;
      -s | --src)
	  src="$2"
	  shift 2
	  ;;
      -d | --dest)
	  dest="$2"
	  shift 2
	  ;;
      -t | --tkt)
          tkt="$2"
          shift 2
          ;;
	* ) usage
	exit 1
    esac
done
## Check if user already exists on destination server

function check_single
{

duser=`$SSH $dest "ls /home | grep -w $user | cut -d/ -f1" 2> /dev/null`

if [[ -z `$SSH $src "grep -w $user /etc/trueuserowners| cut -d: -f1" 2>/dev/null` ]]; then
echo "User $user doesn't exist on $src!!"
exit 1
fi

if [[ $user == $duser ]]; then
	echo -e "\nUser ##$user## already exists on the destination server! Please rename the account ##$user## on **$src** and try again.\n"
	exit 1
    else
        #echo "It's Ok!"
	return 0
fi
} 

## Migration function for only one account

function migration_single
{
## Generate a backup on the source server
$SSH $src "mkdir /home/bkp_$user;/scripts/pkgacct $user /home/bkp_$user" 2> /dev/null
## Transfer backup from source server to Wizard
mkdir ~/TMBKP
$SSH $src "cat /home/bkp_$user/cpmove-$user.tar.gz" > ~/TMBKP/cpmove-$user.tar.gz
## Transfer and restore backup from Wizard to destination server
$SSH $dest "mkdir /home/bkp_$user"; cat ~/TMBKP/cpmove-$user.tar.gz | $SSH $dest "cat > /home/bkp_$user/cpmove-$user.tar.gz"
$SSH $dest "/scripts/restorepkg --skipres /home/bkp_$user/cpmove-$user.tar.gz"


##Clean Files
rm -rf ~/TMBKP
$SSH $src  "rm -rf /home/bkp_$user/"
##Move Backups to HGTRANSF Dir if TKT variable is defined
if [[ -n "$tkt" ]]; then
$SSH $dest "mkdir -p /home/hgtransf/$tkt/;mv /home/bkp_$user/* /home/hgtransf/$tkt/; rm -rf /home/bkp_$user/"
else
$SSH $dest "rm -rf /home/bkp_$user/"
fi
}


## Check if user already exists on destination server

function check_reseller
{

if [[ -z `$SSH $src "grep -w $user /etc/trueuserowners| cut -d: -f1" 2>/dev/null` ]]; then
echo "User $user doesn't exist on $src!!"
exit 1
fi

suser=`$SSH $src "grep -w $user /etc/trueuserowners| cut -d: -f1" 2>/dev/null`
for usr in $suser
do
duser=`$SSH $dest "ls /home | grep -w $usr | cut -d/ -f1" 2>/dev/null`
	if [[ $usr == $duser ]]; then	
		echo -e "User ##$usr## already exists on the destination server! Please rename the account ##$usr## on **$src** and try again."
   	 	z=1
    	fi
done

}

## mIgration function for resellers

function migration_res
{

#Create dirs
mkdir ~/TMBKP
$SSH $src "mkdir /home/bkp_$user"
$SSH $dest "mkdir /home/bkp_$user"

users=`$SSH $src "grep -w $user /etc/trueuserowners| cut -d: -f1"`
for usr in $users
do
## Generate a backup on the source server
$SSH $src "/scripts/pkgacct $usr /home/bkp_$user" 2> /dev/null
## Transfer backup from source server to Wizard
$SSH $src "cat /home/bkp_$user/cpmove-$usr.tar.gz" > ~/TMBKP/cpmove-$usr.tar.gz
## Transfer and restore backup from Wizard to destination server
cat ~/TMBKP/cpmove-$usr.tar.gz | $SSH $dest "cat > /home/bkp_$user/cpmove-$usr.tar.gz"
$SSH $dest "/scripts/restorepkg --skipres /home/bkp_$user/cpmove-$usr.tar.gz"
done

##Clean Files
rm -rf ~/TMBKP
$SSH $src  "rm -rf /home/bkp_$user/"
##Move Backups to HGTRANSF Dir if TKT variable is defined
if [[ -n "$tkt" ]]; then
$SSH $dest "mkdir -p /home/hgtransf/$tkt/;mv /home/bkp_$user/* /home/hgtransf/$tkt/; rm -rf /home/bkp_$user/"
else
$SSH $dest "rm -rf /home/bkp_$user/"
fi

}

if [ "$mode" = "r" ]; then
check_reseller
 if [[ -n "$z" ]]; then
  exit 1
 else
migration_res
exit 1
 fi
fi

check_single
migration_single
