#!/bin/bash
# Jose Terra <jose.terra@endurance.com>
# Linux Systems Administrator II



server=$(hostname)
nasip=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$server | head -n1)
nashome=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$server | head -2| tail -1)
nasdir="${nashome}/${server}"
nasserver=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $nasip "hostname")

red=$(tput setaf 1) 
reset=$(tput sgr0)
green=$(tput setaf 2)

count(){

for logfile in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*.gz| tail -3 | awk '{ print $9}') ; do

  if [ `zcat $logfile | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  count1=$(($count1 + 1))
  fi

done

for logfile in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*[0-9]| tail -3 | awk '{ print $9}') ; do

  if [ `cat $logfile | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  count2=$(($count2 +1))
  fi

done

}


log(){

for logfile in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*.gz| tail -3 | awk '{ print $9}') ; do

  status=$(zcat $logfile |grep -E "Skipping \b${user}\b due to skip file in" | awk '{ print $1}')
  if [ "$status" = "Skipping" ] ; then status="${red}SKIPPED${reset}" ; else status="${green}NON-SKIPPED${reset}" ; fi
  if [ `zcat $logfile | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  zcat $logfile |egrep 'Backing up user' | printf "$(grep -E "\b${user}\b") - $logfile ($status)\n"
  fi

done

for logfile in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*[0-9]| tail -3 | awk '{ print $9}') ; do

  status=$(grep -E "Skipping \b${user}\b due to skip file in" $logfile | awk '{ print $1}')
  if [ "$status" = "Skipping" ] ; then status="${red}SKIPPED${reset}" ; else status="${green}NON-SKIPPED${reset}" ; fi
  if [ `cat $logfile | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  cat $logfile |egrep 'Backing up user' | printf "$(grep -E "\b${user}\b") - $logfile ($status)\n"
  fi

done

}
  

case $1 in

  --user|-u)
  user=$2
  shift 2
  ;; 

esac



homedir=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $nasip " if [ -e "$nasdir/home/$user" ] ; then echo "NON-SKIPPED" ; else echo "SKIPPED" ; fi ")

lastbackup=$(log | egrep 'NON-SKIPPED' |tail -1)

datecdt="Sun Sep 11 23:00:41 CDT 2016"

datebrt=$(date --date='$datecdt')

printf "
INFO NAS
========
- SERVER    => $nasserver ($nasip)
- DIRECTORY => $nasdir

INFO USER
=========
- USER        => $user
- LAST BACKUP => $(if [ $homedir = "NON-SKIPPED" ] ; then echo $lastbackup $dateBRT; else echo "[!] BACKUP INEXISTENTE PARA O USUARIO '$user' !!!"; fi) 

LAST LOGS
=========
$(log)

"
