#!/bin/bash
#
# JOSE RAFAEL DE OLIVEIRA TERRA <jose.terra@endurance.com>
# ADMINISTRADOR DE SISTEMAS LINUX II
#
 
SSH="ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey"
SERVIDOR=$(hostname) 
IPNAS=$(curl -s http://nas.hostgator.com/assign.php?fullquery=${SERVIDOR} | head -n1)
HOMENAS=$(curl -s http://nas.hostgator.com/assign.php?fullquery=${SERVIDOR} | head -2 | tail -1)
DIRNAS="${HOMENAS}/${SERVIDOR}"
NAS=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey ${IPNAS} "hostname")


VERMELHO=$(tput setaf 1) 
RESETAR=$(tput sgr0)
VERDE=$(tput setaf 2)


GERAR_LOGS()

{

for ARQUIVO in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*.gz | tail -n 2 | awk '{ print $9}') ; do

ROTINA=$(zcat ${ARQUIVO} |grep -E "Skipping \b${USUARIO}\b due to skip file in" | awk '{ print $1}')
  if [ "${ROTINA}" = "Skipping" ] ; then ROTINA="${VERMELHO}SKIPPED${RESETAR}" ; else ROTINA="${VERDE}NON-SKIPPED${RESETAR}" ; fi
  if [ `zcat ${ARQUIVO} | egrep 'Backing up user' | grep -E "\b${USUARIO}\b" | wc -l` != "0" ] ; then
  zcat ${ARQUIVO} |egrep 'Backing up user' | printf "$(grep -E "\b${USUARIO}\b") - ${ARQUIVO} ${RESETAR}(${ROTINA})\n"
  fi

done

for ARQUIVO in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*[0-9] | tail -n 6 | awk '{ print $9}') ; do

  ROTINA=$(grep -E "Skipping \b${USUARIO}\b due to skip file in" ${ARQUIVO} | awk '{ print $1}')
  if [ "${ROTINA}" = "Skipping" ] ; then ROTINA="${VERMELHO}SKIPPED${RESETAR}" ; else ROTINA="${VERDE}NON-SKIPPED${RESETAR}" ; fi
  if [ `cat ${ARQUIVO} | egrep 'Backing up user' | grep -E "\b${USUARIO}\b" | wc -l` != "0" ] ; then
  cat ${ARQUIVO} |egrep 'Backing up user' | printf "$(grep -E "\b${USUARIO}\b") - ${ARQUIVO} ${RESETAR}(${ROTINA})\n"
  fi

done

}


OBTER_ULTIMO_BACKUP_NOSKIP()

{

BACKUP=$(GERAR_LOGS | egrep 'NON-SKIPPED' |tail -1) 

if [ `GERAR_LOGS | egrep 'NON-SKIPPED' | wc -l` != "0" ] ; then

  FORMATAR_DATA=$(date --date="$(echo ${BACKUP}| cut -d: -f1-3)") 
  FORMATAR_INFO=$(echo ${BACKUP} | cut -d: -f4-5)       
  echo "${VERDE}${FORMATAR_DATA} :${FORMATAR_INFO}${RESETAR}"

fi

}


CHECAR_DIRETORIO_HOME_NAS()

{

DIRHOME=$(${SSH} ${IPNAS} "if [ -e "${DIRNAS}/home/${USUARIO}" ] ; then echo "[OK]" ; fi ")
if [ "${DIRHOME}" = "[OK]" ] ; then echo "${VERDE}${DIRNAS}/home/${USUARIO}${RESETAR}" ; fi

}


MOSTRAR_AJUDA()

{

printf "
VERIFICAR BACKUP HOME DISPONIVEL PARA O USUARIO NO SERVIDOR NAS
===============================================================
bash <(GET http://git.gatorterra.com/buphome.sh) --usuario [USUARIO-CPANEL] 

[*] - EXECUTAR DIRETAMENTE NO SERVIDOR DO USUARIO
[*] - DUVIDAS OU SUGESTOES ENVIE EMAIL PARA <jose.terra@endurance.com>

"

}


if [ "$#" -lt "2" ] ; then  MOSTRAR_AJUDA ; exit 0 ; fi

while [ "$1" != "" ] ; do

case $1 in

  --usuario)
  USUARIO=$2
  shift 2
  ;;
  
  *)
  MOSTRAR_AJUDA
  exit 0
  ;;

esac
done


FORMATAR_HORA_BRT=$(mv -f /etc/localtime{,.HGBACK} ; ln -sf /usr/share/zoneinfo/America/Sao_Paulo /etc/localtime ; date)

printf "
[*] SERVIDOR NAS
================
${VERDE}${NAS} (${IPNAS})${RESETAR}

[*] ULTIMO BACKUP HOME (SE DISPONIVEL)
======================================
$(OBTER_ULTIMO_BACKUP_NOSKIP) 

[*] DIRETORIO HOME DO USUARIO NO SERVIDOR NAS (SE DISPONIVEL)
=============================================================
$(CHECAR_DIRETORIO_HOME_NAS)

[*] LOGS DA ROTINA (HORARIO DE INICIO DO BACKUP PARA O USUARIO)
===============================================================
$(GERAR_LOGS)

"
