#!/bin/bash

##################################################################
# Author       : Leonardo I. Peixoto
# Email        : contato@leonardopeixoto.com
# Info         : Script para auxiliar na remoção de um dominio trancado no cPanel!
##################################################################
#Debug
#set -x

VERMELHO=$(tput setaf 1) 
RESETAR=$(tput sgr0)
VERDE=$(tput setaf 2)

HELP() {
echo "\n FALTA ARGUMENTO OU CONTATE L1 PEIXOTO\n" ;
}

if [ "$#" -lt "4" ] ; then HELP ; exit 0 ; fi

while [ "$1" != "" ] ; do

case $1 in

--d|--dominio)
DOMINIO="$2"
if [ -z "$DOMINIO" ] ; then HELP ; exit 0 ; fi
shift 2
;;

--u|--usuario)
USUARIO="$2"
if [ -z "$USUARIO" ] ; then HELP ; exit 0 ; fi
shift 2
;;

esac
done
echo "[-]"
echo "[+] - Removendo dominio da zona de DNS"
/script/killdns $DOMINIO

echo "[-]"
echo "[+] - Removendo dominio da entrade de virtual host"
/script/killvhost $DOMINIO

echo "[-]"
echo "${VERDE}[+] - Remover o domínio das entradas que aparecerem!${RESETAR}"
echo "${VERMELHO}[+]#####################################################${RESETAR}"
grep --color $DOMINIO /var/cpanel/users/*
grep --color $DOMINIO /var/cpanel/userdata/$USUARIO/main 
grep --color $DOMINIO /var/cpanel/userdata/$USUARIO/*
grep --color $DOMINIO /etc/trueuserdomains
grep --color $DOMINIO /etc/localdomains
echo "${VERMELHO}[+]#####################################################${RESETAR}"
echo "[-]"
echo "[+] - Limpando cache"
	
	/scripts/updateuserdomains; 
	/scripts/update_db_cache

